function Zip_initialize(){
	system_alert('Zip initializing complete');
}
var store2 = null;
function zip_store_to_dialogue(){
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fileChooser = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fileChooser.init(window, "Select a Location to save",nsIFilePicker.modeSave);
	fileChooser.appendFilters( nsIFilePicker.filterAll);
	var fileBox = fileChooser.show();
	if (fileBox == nsIFilePicker.returnOK || nsIFilePicker.returnReplace) {
		var returnfile = fileChooser.file;
		var returnpath = fileChooser.file.path;
	}
	return returnfile;
}
function zip_extract_dialogue(){
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
      var file = zip_choose_dialogue();
        var fileName = file.leafName;
        var extensionDelimiter = fileName.lastIndexOf(".");
          var prefix = fileName.substr(0, extensionDelimiter);
        store2 = zip_store_to_dialogue();
	store2.append(prefix);
          //alert(store2.path);
          if( !store2.exists() || !store2.isDirectory() ) { // if it doesn't exist, create
                store2.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777); }
          //alert(store2.path);
      zip_extract_files(prefix, file);
}
function zip_install_app_dialogue(){
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
      var file = zip_choose_dialogue('app');
        var fileName = file.leafName;
        var extensionDelimiter = fileName.lastIndexOf(".");
          var prefix = fileName.substr(0, extensionDelimiter);
         store2 = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	store2.initWithPath( homeDir+'\\apps\\' );  
	store2.append(prefix);
          //alert(store2.path);
          if( !store2.exists() || !store2.isDirectory() ) { // if it doesn't exist, create
                store2.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777); }
          //alert(store2.path);
      zip_extract_files(prefix, file);
}

function zip_choose_dialogue(type){
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    const nsIFilePicker = Components.interfaces.nsIFilePicker;

    var fp = Components.classes["@mozilla.org/filepicker;1"]
                   .createInstance(nsIFilePicker);
    fp.init(window, "Install App", nsIFilePicker.modeOpen);
	if(type=='app'){
		fp.appendFilter("jBOS App","*.jba;");
	}
    fp.appendFilters(nsIFilePicker.filterAll);
    var rv = fp.show();
    if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
      var file = fp.file;
      // Get the path as string. Note that you usually won't
      // need to work with the string paths.
      var path = fp.file.path;
      // work with returned nsILocalFile...
      return file;
   
        }
}

function zip_extract_files(extensionID, zipFile) {
  	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

    var zipReader = Components.classes["@mozilla.org/libjar/zip-reader;1"]
                                     .createInstance(Components.interfaces.nsIZipReader);
    zipReader.open(zipFile);
    zipReader.test(null);
    // create directories first
    var entries = zipReader.findEntries("*\\");
    while (entries.hasMore()) {
      var entryName = entries.getNext();
      var target = zip_get_item_file(entryName);
      if (!target.exists()) {
        try {
          target.create(Components.interfaces.nsILocalFile.DIRECTORY_TYPE, 0777);
        }
        catch (e) {
          event_notify('Zip Error',"zip_extract_files: failed to create target directory for extraction " +
                " file = " + target.path + ", exception = " + e + "\n");
        }
      }
    }

    entries = zipReader.findEntries(null);
    while (entries.hasMore()) {
      var entryName = entries.getNext();
      target = zip_get_item_file(entryName);
      if (target.exists())
        continue;

      try {
        target.create(Components.interfaces.nsILocalFile.DIRECTORY_TYPE, 0777);
      }
      catch (e) {
        event_notify('Zip Error',"zip_extract_files: failed to create target file for extraction " +
              " file = " + target.path + ", exception = " + e + "\n");
      }
      zipReader.extract(entryName, target);
    }
    zipReader.close();
  }

function zip_get_item_file( filePath) {
    //alert(store2.path);
    var itemLocation = store2.clone();
    var parts = filePath.split("\\");
    for (var i = 0; i < parts.length; ++i)
      itemLocation.append(parts[i]);
    return itemLocation;
  }
